/*
THIS FILE IS A PART OF GTA V SCRIPT HOOK SDK
http://dev-c.com
(C) Alexander Blade 2015
*/

#include "script.h"

#include <string>
#include <ctime>
#include <vector>
#include <map>

std::string statusText;
Player player;
Ped ped1;
Ped pedx;
int KEY = VK_SUBTRACT;
bool active = false;
bool wasToggled = false;
long count;

void set_status_text(std::string str)
{
	statusText = str;
}

void update_status_text()
{
	UI::SET_TEXT_FONT(0);
	UI::SET_TEXT_SCALE(0.55, 0.55);
	UI::SET_TEXT_COLOUR(255, 255, 255, 255);
	UI::SET_TEXT_WRAP(0.0, 1.0);
	UI::SET_TEXT_CENTRE(1);
	UI::SET_TEXT_DROPSHADOW(0, 0, 0, 0, 0);
	UI::SET_TEXT_EDGE(1, 0, 0, 0, 205);
	UI::_SET_TEXT_ENTRY("STRING");
	UI::_ADD_TEXT_COMPONENT_STRING((char *)statusText.c_str());
	UI::_DRAW_TEXT(0.5, 0.5);
}

bool get_key_pressed(int nVirtKey)
{
	return (GetAsyncKeyState(nVirtKey) & 0x8000) != 0;
}

bool mod_switch_pressed()
{
	return get_key_pressed(KEY);
}

void main()
{
	FILE * pFile;
	pFile = fopen("meleeriot.ini", "r");

	if (pFile)
	{
		fscanf(pFile, "%x", &KEY);
		fclose(pFile);
	}

	std::vector <Ped> peds;
	count = 0;

	while (true)
	{
		player = PLAYER::PLAYER_PED_ID();
		int playerGroup = PLAYER::GET_PLAYER_GROUP(player);
		Vector3 pos = ENTITY::GET_ENTITY_COORDS(player, true);

		for (int i = 0; i<peds.size(); i++)
		{
			Vector3 pedpos = ENTITY::GET_ENTITY_COORDS(peds.at(i), true);
			if (!ENTITY::DOES_ENTITY_EXIST(peds.at(i))) { peds.erase(peds.begin() + i); break; }
			else
				if (PED::IS_PED_HUMAN(peds.at(i))) { ENTITY::SET_PED_AS_NO_LONGER_NEEDED(&peds.at(i)); peds.erase(peds.begin() + i); break; }
				else
					if (GAMEPLAY::GET_DISTANCE_BETWEEN_COORDS(pos.x, pos.y, pos.z, pedpos.x, pedpos.y, pedpos.z, true)>600)  { ENTITY::SET_PED_AS_NO_LONGER_NEEDED(&peds.at(i)); peds.erase(peds.begin() + i); break; }
					else
						if (PED::_IS_PED_DEAD(peds.at(i), true)) { peds.erase(peds.begin() + i); break; } // dead peds
						else
							if (!PED::IS_PED_IN_COMBAT(peds.at(i), true))
							{
								long rioters = peds.size();

								if (rioters>1)
								{
									long r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters);
									pedx = peds.at(r);
									ped1 = peds.at(i);
									if ((!PED::IS_PED_GROUP_MEMBER(ped1, playerGroup))) //excludes bodyguards
									{
										if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); pedx = peds.at(r); }
										if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); pedx = peds.at(r); }
										if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); pedx = peds.at(r); }

										if ((pedx != ped1) && PED::IS_PED_HUMAN(ped1))
										{

											if ((ENTITY::DOES_ENTITY_EXIST(pedx)))
											{
												AI::CLEAR_PED_TASKS(ped1);
												AI::CLEAR_PED_SECONDARY_TASK(ped1);
												PED::SET_BLOCKING_OF_NON_TEMPORARY_EVENTS(ped1, 1);
												PED::SET_PED_FLEE_ATTRIBUTES(ped1, 0, 0);
												PED::SET_PED_COMBAT_ATTRIBUTES(ped1, 46, TRUE);
												PED::SET_BLOCKING_OF_NON_TEMPORARY_EVENTS(pedx, 1);
												PED::SET_PED_FLEE_ATTRIBUTES(pedx, 0, 0);
												PED::SET_PED_COMBAT_ATTRIBUTES(pedx, 46, TRUE);
												if (pedx != player)
													AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, pedx, 0, 0, 0, 0);
												if ((AI::IS_PED_STILL(ped1)) && ((PED::IS_PED_IN_MELEE_COMBAT(player)) || (PED::IS_PED_IN_COMBAT(player, true))))
													AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, player, 0, 0, 0, 0);
												//if (AI::IS_PED_STILL(ped1)) //( && (r % 2 == 0))
												//	AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, player, 0, 0, 0, 0);
											}
										}
									}
								}
							}
		} //end of for loop

		if (mod_switch_pressed()){
			if (active == false){
				set_status_text("ENABLING MELEE RIOT"); update_status_text();
			} else 
				set_status_text("DISABLING MELEE RIOT"); update_status_text();
			wasToggled = true;	
		} else // if the mod button was depressed and let go, check to see if it had been depressed once before that, and make mod inactive if true
			if (wasToggled == true)
			{
			wasToggled = false;
			active = !active;
			}

		count++;

		//-------------------------------------------------------------------------------------------------

		if ((count>50) && (active == true))
		{
			count = 0;
			playerGroup = PLAYER::GET_PLAYER_GROUP(player);
			player = PLAYER::PLAYER_PED_ID(); //just in case the player changes his or her player model during the mod
			Vector3 pos = ENTITY::GET_ENTITY_COORDS(player, true);

			const int femweapon = 20; //every number greater than 10 leaves the rioter unarmed
			const int menweapon = 300;
			char *weapons[femweapon] = { "WEAPON_DAGGER", "WEAPON_KNIFE", "WEAPON_BAT", "WEAPON_CROWBAR", "WEAPON_GOLFCLUB", "WEAPON_HAMMER", "WEAPON_HATCHET", "WEAPON_NIGHTSTICK", "WEAPON_BOTTLE", "WEAPON_BAT" };
			char *weapons2[menweapon] = { "WEAPON_DAGGER", "WEAPON_KNIFE", "WEAPON_BAT", "WEAPON_CROWBAR", "WEAPON_GOLFCLUB", "WEAPON_HAMMER", "WEAPON_HATCHET", "WEAPON_NIGHTSTICK", "WEAPON_BOTTLE", "WEAPON_BAT" };

			const int numElements = 100;
			const int arrSize = (numElements + 1) * sizeof(Any);
			Object nearbypeds[arrSize];
			nearbypeds[0] = numElements;

			int count = PED::GET_PED_NEARBY_PEDS(player, nearbypeds, -1);

			if (nearbypeds != NULL)
			{

				for (int i = 0; i < count; i++)
				{
					int offsettedID = i * sizeof(Object) + 2;
					ped1 = nearbypeds[offsettedID];

					if ((ped1 != player) && (ped1 != NULL && ENTITY::DOES_ENTITY_EXIST(ped1)) && (PED::IS_PED_HUMAN(ped1)) && (!PED::IS_PED_GROUP_MEMBER(ped1, playerGroup)))
					{
		
						int ok = 1;
						for (int j = 0; j<peds.size(); j++)
							if (peds.at(j) == ped1) ok = 0;

						if (ok)
						{
							if (PED::IS_PED_IN_ANY_VEHICLE(ped1, true))
							{
								PED::SET_PED_KEEP_TASK(ped1, 1);
								Object task;
								PED::SET_PED_FIRING_PATTERN(ped1, GAMEPLAY::GET_HASH_KEY("FIRING_PATTERN_BURST_FIRE_DRIVEBY"));
								AI::OPEN_SEQUENCE_TASK(&task);
								if (PED::IS_PED_HUMAN(pedx))
									AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, pedx, 0, 0, 0, 0); //ped in car vs player
								AI::TASK_PAUSE(ped1, 16);
								AI::TASK_LEAVE_ANY_VEHICLE(0, 0, 1 << 8);
								AI::TASK_STAND_STILL(0, -1);
								if (((PED::IS_PED_IN_MELEE_COMBAT(player)) || (PED::IS_PED_IN_COMBAT(player, true))))
									AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, player, 0, 0, 0, 0);
								AI::CLOSE_SEQUENCE_TASK(task);
								AI::TASK_PERFORM_SEQUENCE(ped1, task);
								PED::RESET_PED_LAST_VEHICLE(ped1);
							}
							PED::SET_BLOCKING_OF_NON_TEMPORARY_EVENTS(ped1, 1);
							PED::SET_PED_FLEE_ATTRIBUTES(ped1, 0, 0);
							PED::SET_PED_COMBAT_ATTRIBUTES(ped1, 46, TRUE);
							
							if (PED::IS_PED_HUMAN(ped1) && (ped1 != player))  // give weapon to male and female peds
								if ((!WEAPON::IS_PED_ARMED(ped1, 0xFF)) && (!PED::IS_PED_IN_COMBAT(ped1, true)))
								{
									Any weaponhashF = GAMEPLAY::GET_HASH_KEY(weapons[GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, femweapon)]);
									if ((WEAPON::IS_WEAPON_VALID(weaponhashF)) && (!PED::IS_PED_MALE(ped1)))
										WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, weaponhashF, 300, 1);
									Any weaponhashM = GAMEPLAY::GET_HASH_KEY(weapons2[GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, menweapon)]);
									if ((WEAPON::IS_WEAPON_VALID(weaponhashM)) && (PED::IS_PED_MALE(ped1)))
										WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, weaponhashM, 300, 1);
									WEAPON::SET_PED_DROPS_WEAPONS_WHEN_DEAD(ped1, 0);
								}

							peds.push_back(ped1); //go back one element in the vector
							long rioters = peds.size();

							if (rioters>1)
							{
								int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); Ped pedx = peds.at(r);
								if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); Ped pedx = peds.at(r); }
								if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); Ped pedx = peds.at(r); }
								if (pedx == ped1) { int r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, rioters); Ped pedx = peds.at(r); } // check 3 times to make sure pedx is not ped1
								if (pedx != ped1)

									if ((ENTITY::DOES_ENTITY_EXIST(pedx)) && (PED::IS_PED_HUMAN(pedx)))
									{
										DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(81, ped1, 180000.0);
										DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(94, ped1, 180000.0);
										DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(98, ped1, 180000.0);
										DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(99, ped1, 180000.0);
										DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(0xFFFFFF, ped1, 180000.0);
										PED::REMOVE_PED_FROM_GROUP(ped1);
										AI::CLEAR_PED_TASKS(ped1);
										AI::CLEAR_PED_SECONDARY_TASK(ped1);
										if (pedx != player)
											AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, pedx, 0, 0, 0, 0);
										if ((AI::IS_PED_STILL(ped1)) && ((PED::IS_PED_IN_MELEE_COMBAT(player)) || (PED::IS_PED_IN_COMBAT(player, true))))
											AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, player, 0, 0, 0, 0);

									}
							}

						}
					}
				}
			}
		} //end "if count > 50" 
		WAIT(0);
	} //end while
} //end main()

void ScriptMain()
{
	srand(GetTickCount());
	main();
}
